// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import static net.cellcomputing.himawari.library.EqModeBlock.*;
import net.cellcomputing.himawari.accessory.STLVector;

/**
 * Define the context that exists between calls to RiWorldBegin/RiWorldEnd.<br>
 *  RiWorldBegin/RiWorldEndĂтĂԂɑ݂AReLXg`B
 * 
 * @author NTT DATA Corporation
 */
public strictfp class CqWorldModeBlock extends CqModeBlock
{
	
	/**
	 * RXgN^B@l̐ݒB
	 * @param pconParent	ÕReLXgB
	 */
	public CqWorldModeBlock( final CqModeBlock pconParent )
	{
		super(pconParent, World);
	 
		// Create new Attributes as they must be pushed/popped by the state change.
	    // Ԃ̕ωŕςAgr[gV쐬B
		m_pattrCurrent = new CqAttributes( pconParent.m_pattrCurrent );
	    m_pattrCurrent.AddRef();
	    m_ptransCurrent = new CqTransform( pconParent.m_ptransCurrent );
	}

	/** 
	 * fXgN^B@<br>
	 * QƂ̏B@(QƃJE^fNgB)
	 * @see net.cellcomputing.himawari.library.CqModeBlock#destruct()
	 */
	@Override
	public void destruct()
	{
		m_pattrCurrent.Release();
	}


    /**
     * Create a main context.<br>
     * 	C̃ReLXg쐬B
     * 
     * @warning [hReLXg̒ŁÃ\bhĂ΂ꂽꍇG[ƂȂB
     */
	@Override
    public CqModeBlock BeginMainModeBlock()
    {
        return  null;	// Error
    }	
    
    /** 
     * Create a frame context.<br>
     *@	t[̃ReLXg쐬B
     *
     * @warning [hReLXg̒ŁÃ\bhĂ΂ꂽꍇG[ƂȂB
     */
	@Override
    public CqModeBlock BeginFrameModeBlock()
    {
        return  null;	// Error
    }	
	
    /** 
     * Create a world context.<br>
     * 	[h̃ReLXg쐬B
     * 
     * @warning [hReLXg̒ŁÃ\bhĂ΂ꂽꍇG[ƂȂB
     */
	@Override
    public CqModeBlock	BeginWorldModeBlock()
    {
        return 	null;	// Error
    }	

    /** 
     * Delete the world context.<br>
     * 	[hReLXgB
     * 
     * @attention ̃\bĥ݁A[h̃ReLXg邱ƂłB
     */
	@Override
    public	void	EndWorldModeBlock()
    {
		destruct();
    }

    /** 
     * Get a reference to the options at the parent context, <br>
     * as world context doesn't store options.<br>
     *  ẽReLXg̃IvṼQb^B<br>@
     *  ([hReLXg̓IvVۑȂB)
     *  
     * @return ݂̃IvV
     */
	@Override
    public	CqOptions	optCurrent()
    {
        return ( pconParent().optCurrent() );
    }
	
	
	/**
	 * Hold a reference to the specified lightsource in this context.<br>
     * 	̃ReLXgŎw肳ꂽ̎QƂ
     *
     * @param	pLS ̏
	 * @see net.cellcomputing.himawari.library.CqModeBlock#AddContextLightSource(net.cellcomputing.himawari.library.CqLightsource)
	 */
	@Override
    public void AddContextLightSource( final CqLightsource pLS )
    {
        // Add the light to the context stack.
    	//@ReLXg̃X^bNɃCg\[XǉB
        m_apWorldLights.add( pLS );
    }

    private STLVector<CqLightsource> m_apWorldLights = new STLVector<CqLightsource>( CqLightsource.class );
}
