/// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

/**
 * 
 * 
 * 
 * @author NTT DATA Corporation
 */

//----------------------------------------------------------------------
/** \enum EqShaderType
 * Shader type identifier.
 * VF[_^CvʎqB
 */
public strictfp class EqShaderType {
	public final static int Type_Surface = 0;   			///< Surface shader
	public final static int Type_Lightsource = 1;   		///< Lightsource shader.
	public final static int Type_Volume = 2;   			///< Volume shader.
	public final static int Type_Displacement = 3;   		///< Displacement shader.
	public final static int Type_Transformation = 4;   	///< Transformation shader.
	public final static int Type_Imager = 5;   			///< Image shader.

	private int value;
	
	public EqShaderType(int value) {
		this.value = value;
	}
	
	
	public int getValue()
	{
		return value;
	}
	public void setValue(int val)
	{
		value = val;
	}
}
