// Aqsis
// Copyright (c) 1997 - 2001, Paul C. Gregory
//
// Contact: pgregory@aqsis.com
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.library;

import net.cellcomputing.himawari.accessory.STLVector;


/**
 * Interface to the data handled by the K-DTree, implementation provided.
 * 
 * 
 * @author NTT DATA Corporation
 */
public strictfp interface IqKDTreeData<T> {

    /**
     * Function to sort the elements in the given array, in ascending order based on the specified dimension index.
     * 
     * 
     * @param aLeaves	t
     * @param dimension	
     */
    public void SortElements( STLVector<T> aLeaves, int dimension);
    
    /**
     * Return the number of dimensions in the tree data.
     * 
     * 
     * @return	
     */
    public int Dimensions();
    
}
