/*
 KeywordNuPatch.java
 Copyright (C) 2003 Gerardo Horvilleur Martinez

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 * Copyright (C) 2006-2007  NTT DATA CORPORATION
 * 
 * Version: 1.0.0 2007/04/01
 *  
 */
package net.cellcomputing.himawari.parser.keywords;

import net.cellcomputing.himawari.library.RendermanInterface;
import net.cellcomputing.himawari.parser.Tokenizer;

public strictfp class KeywordNuPatch extends AbstractKeywordParser {

    public void parse(Tokenizer st) throws Exception {
        // Expect nu
        match(st, TK_NUMBER);
        int nu = (int)st.nval;
        
        // Expect u order
        match(st, TK_NUMBER);
        int uorder = (int)st.nval;
        
        // Expect u knot
        parseArray(st);
        float[] uknot = toFloat();
        
        // Expect u min
        match(st, TK_NUMBER);
        int umin = (int)st.nval;
        
        // Expect u max
        match(st, TK_NUMBER);
        int umax = (int)st.nval;
        
        // Expect nv
        match(st, TK_NUMBER);
        int nv = (int)st.nval;
        
        // Expect v order
        match(st, TK_NUMBER);
        int vorder = (int)st.nval;
        
        // Expect v knot
        parseArray(st);
        float[] vknot = toFloat();
        
        // Expect v min
        match(st, TK_NUMBER);
        int vmin = (int)st.nval;
        
        // Expect v max
        match(st, TK_NUMBER);
        int vmax = (int)st.nval;
        
        // Expect parameter list
        parseParameterList(st);
        
        RendermanInterface.RiNuPatchV( nu, uorder, uknot, umin, umax, nv, 
        					vorder, vknot, vmin, vmax, count(), tokens(), values() );
    }

}
